/**********************************************************************
* Copyright (c) 2013-2014  Red Hat, Inc.
*
* Developed by Daynix Computing LTD.
*
* Authors:
*     Dmitry Fleytman <dmitry@daynix.com>
*     Pavel Gurvich <pavel@daynix.com>
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*
**********************************************************************/

#pragma once

#include "targetver.h"

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
#endif

#include <stdio.h>
#include <assert.h>
#include <tchar.h>
#include <windows.h>
#include <cfgmgr32.h>
#include <initguid.h>
#include <rpc.h>

#ifndef _USING_V110_SDK71_
#include <usbspec.h>
#include <Usbiodef.h>
#else
#define TARGET_OS_WIN_XP (1)
#include "UsbDkHlprCompat.h"
#endif

#include <memory>
#include <ios>
#include <vector>
#include <winscard.h>

//new behavior: elements of array 'array' will be default initialized
#pragma warning(disable : 4351)

#include "tstrings.h"
#include "Exception.h"
#include "Utils.h"
#include "ServiceManager.h"

using namespace std;
